%Approximation by DFT of windowed chirp function 
clear;
close all hidden;

a=0;b=1;N=1024;t = a:(1/N)*(b-a):b-(1/(N*(b-a))); 
freq = 25;
g=sin(freq*pi*t.*t);
%g = 0.3*sin(11.3*2*pi*t)+0.5*sin(12.7*2*pi*t);

%%
figure;
plot(t,g);
axis tight;
%axis([a,b,-1.5,1.5])
title('Signal')
xlabel('time t')


for fs = 100:-20:20
    %[w,ghut,wmin,wmax]=ctft(a,b,N,t,g,0,128,1);
    %fs = 40;
    omega_max = fs/2;
    [w,ghut,wmin,wmax]=ctft(a,b,N,t,g,0,omega_max,10);    
    N_sample=b*fs;t_sample = a:(1/N_sample)*(b-a):b-(1/(N_sample*(b-a)));
    g_sample=(sin(freq*pi*t_sample.*t_sample));
    %g_sample = 0.3*sin(11.3*2*pi*t_sample)+0.5*sin(12.7*2*pi*t_sample);
    ghut_sample = (1/fs)*fft(g_sample);
    %figure;
    %plot(abs(ghut))
    k_axis = (0:N_sample-1);

    figure;
    plot(w,abs(ghut(wmin:wmax)))
    axis([0,omega_max,0,0.3])
    title('Continuous and approximated Fourier transform')
    xlabel('frequency \omega')
    hold on;
    stem(k_axis,abs(ghut_sample),'.r')
end

